# dsin(x)/dx
import math as m
import numpy as np
import matplotlib.pyplot as plt

def sin(x):
  return np.sin(x)

# two point formula
def df_dx_forward(f, x, h):
  return (f(x+h)-f(x))/h

def df_dx_backward(f, x, h):
  return (f(x)-f(x-h))/h

if __name__=="__main__":
  x=np.linspace(0, 2*np.pi, 1000)
  dydx_f=np.zeros(len(x))
  dydx_b=np.zeros(len(x))
  h=1e-6
  
  i=0
  for xx in x:
    dydx_f[i]=df_dx_forward(sin, xx, h)
    dydx_b[i]=df_dx_backward(sin, xx, h)
    i+=1
  
  plt.plot(x, dydx_f, 'b-.')
  plt.plot(x, dydx_b, 'r--')
  plt.show()
